##
#
##
proc Katyusha_Heritages_MAJ_lignes_table_mere {id_heritage} {
    global heritages
    global heritages_graphique
    global tables_graphique
    global lignes_graphique
    
    set heritage [dict get $heritages $id_heritage]
    
    # Récupère l'ID-canvas du triangle de l'affichage graphique de l'héritage pour récupérer ses coordonnées
    set id_graphique [lindex [dict get $heritages_graphique $id_heritage] 0]
    set coords_heritage [.mcd.canvas.c coords $id_graphique]
    
    # Pour la table mere, on part du haut du triangle
    set x_origine [lindex $coords_heritage 4]
    set y_origine [lindex $coords_heritage 5]
    
    # Récupère l'ID-canvas de la table mère
    set id_mere [dict get $heritage "mere"]
    set id_graphique_mere [lindex [dict get $tables_graphique $id_mere] 0]
    set coords_mere [.mcd.canvas.c coords $id_graphique_mere]
    
    # Récupère le dictionnaire des tables filles pour la ligne
    set filles [dict get $heritage "filles"]
    
    # Les coordonnées d'arrivées sont au milieu bas de la table mère
    set x_arrivee [expr [lindex $coords_mere 0] + (([lindex $coords_mere 2] - [lindex $coords_mere 0]) / 2)]
    set y_arrivee [lindex $coords_mere 3]
    
    # ID par défaut de la ligne à créer
    set id_ligne [dict size $lignes_graphique]
puts $id_ligne
    
    # Recherche dans les lignes existantes si celle qu'on souhaite créer existe déjà
    foreach {k ligne} $lignes_graphique {
        if {[lindex $ligne 0] == "heritage"} {
            # Si c'est le cas, on la supprimme pour la recréer aux nouvells coordonnées
            if {[lindex $ligne 3] == $id_heritage} {
                .mcd.canvas.c delete [lindex $ligne 1]
                set $id_ligne $k
            }
        }
    }
    # Créé la nouvelle ligne
    dict set lignes_graphique $id_ligne [list "heritage" [.mcd.canvas.c create line $x_origine $y_origine $x_arrivee $y_arrivee -arrow last -arrowshape [list 20 22 8] -width 3 -dash [list 15 5] -fill #FF7000 -tag [list ligne_heritage $id_mere $id_heritage]] $id_mere $id_heritage $filles]
}

##
#
##
proc Katyusha_Heritages_MAJ_lignes_tables_filles {id_heritage} {
    global heritages
    global heritages_graphique
    global tables_graphique
    global lignes_graphique
    
    set heritage [dict get $heritages $id_heritage]
    
    # Récupère l'ID-canvas du triangle de l'affichage graphique de l'héritage pour récupérer ses coordonnées
    set id_graphique [lindex [dict get $heritages_graphique $id_heritage] 0]
    set coords_heritage [.mcd.canvas.c coords $id_graphique]
    
    # Boucle pour toutes les tables filles
    set filles [dict get $heritage "filles"]
    set id_mere [dict get $heritage "mere"]
    foreach {k id_fille} $filles {
        # Pour les tables filles, on part du bas du triangle
        set x_origine [lindex $coords_heritage 0]
        set y_origine [lindex $coords_heritage 1]
        
        set id_graphique_fille [lindex [dict get $tables_graphique $id_fille] 0]
        set coords_fille [.mcd.canvas.c coords $id_graphique_fille]
        
        # Les coordonnées d'arrivées sont au milieu haut de la table fille
        set x_arrivee [expr [lindex $coords_fille 0] + (([lindex $coords_fille 2] - [lindex $coords_fille 0]) / 2)]
        set y_arrivee [lindex $coords_fille 1]
        
        # ID par défaut de la ligne à créer
        set id_ligne [dict size $lignes_graphique]
puts $id_ligne
        
        # Recherche dans les lignes existantes si celle qu'on souhaite créer existe déjà
        foreach {kk ligne} $lignes_graphique {
            if {[lindex $ligne 0] == "heritage"} {
                # Si c'est le cas, on la supprimme pour la recréer aux nouvells coordonnées
                if {[lindex $ligne 3] == $id_heritage && [dict get [lindex $ligne 4] $k] == $id_fille} {
                    .mcd.canvas.c delete [lindex $ligne 1]
                    set $id_ligne $kk
                }
            }
        }
    # Créé la nouvelle ligne
    dict set lignes_graphique $id_ligne [list "heritage" [.mcd.canvas.c create line $x_origine $y_origine $x_arrivee $y_arrivee -arrow first -arrowshape [list 20 22 8] -width 3 -dash [list 15 5] -fill #FF7000 -tag [list ligne_heritage $id_mere $id_heritage]] $id_mere $id_heritage $filles]
    }
puts $lignes_graphique
}
